VisualEditor: Support for right-to-left (rtl) / bidirectional content (tracking)
Closed, ResolvedPublic

Assigned To
Jdforrester-WMF
Priority
Normal
Author
Amire80
Blocks
T35077: VisualEditor multilingual input / i18n issues (tracking)
T4007: Tracking bug (tracking)
T2745: RTL/bidirectional issues (tracking)
T53792: VisualEditor: Non-English Wikipedia issues (tracking)
Blocked By
T87637: VisualEditor formula insertion field must always be ltr and not rtl
T76474: VisualEditor page options menu goes off-screen in RTL wikis
T76463: VisualEditor image resize icon must be flipped and moved to the opposite edge for RTL wikis
T71969: In the media adding dialog, LTR direction is forced on the description field even in RTL wikis
T75379: Table column adding icon must be flipped for RTL
T75378: Table row selector is shown incorrectly in RTL
T68037: VisualEditor: Add reference (footnote) dialog is LTR in RTL wikis
T71165: VisualEditor: In the image advanced settings dialog, the alignment button order is wrong in RTL UI
T74673: VisualEditor: Edit notices popup shows out of screen in RTL
T74668: VisualEditor: Content menu is embedding off-screen for left-floated node in RTL environment
T70688: VisualEditor: version number in the help panel must be bidi-isolated
T67483: VisualEditor: Category autocompletion is broken in RTL wikis
T65593: VisualEditor: Some icons need to be flipped for RTL languages
T62187: VisualEditor: Provide a language inspector to handle <div lang='xx' dir='yyy'> blocks and similar
T58780: VisualEditor: The default direction of the <textarea> for editing the content of <source> must be LTR
T58779: VisualEditor: The direction of the <textarea> in extension tags editor must correspond to the surrounding content direction
T53490: In RTL (hewiki and arwiki) wikis, can't remove categories
T66872: VisualEditor: Ctrl+cursor (Opt+cursor on Mac) moves the caret too far in Hebrew
T53401: VisualEditor: Page loading animated image is only LTR
T55161: Infobox widget floats right in RTL Wikis
T53295: VisualEditor: Default insert type for RTL wikis should be thumb|left not thumb|right
T51613: Page settings dialog is not oriented for RTL
T51546: VisualEditor: CSS broken in RTL
T51416: VisualEditor: Link inspector surface doesn't pop up when the user language is right-to-left
T49814: RTL Support for VisualEditor
T52910: VisualEditor: CE CSS munging issue with specific (highly used) hewiki template
T52905: VisualEditor: Transclusion icon appears on the opposite side of the page in RTL wikis
T49759: VisualEditor: Provide a language inspector to handle inline <span lang='xx' dir='yyy'>s
T49746: VisualEditor: Aliens' phantoms don't appear in the Hebrew Wikipedia (cache/CSSJanus issue?)
T49717: VisualEditor: Link inspector input text always has LTR direction
T52543: VisualEditor: "[edit | edit source]" appears jumbled in RTL wiki with LTR interface
T52490: VisualEditor: Link input widget is not oriented for RTL
T50912: VisualEditor: {Ctrl,Option}+{Delete,Backspace} doesn't delete a word in an RTL wiki
T52436: TemplateData: Creating TemplateData blocks should be direction neutral
T53978: VisualEditor: A template with the RLM control character doesn't work when editing in VE
T53852: Image options should be serialized in the wiki's language in rtl locales - localization i18n
T53851: VisualEditor: By default, images should not set the alignment
T53828: VisualEditor: Autocompletion for template names doesn't work in RTL
T53819: VisualEditor: Location of the inspector menu is wrong for floated content in RTL wikis
T40545: VisualEditor: down arrow in drop-down menu in RTL interface overlaps with the text
T40547: VisualEditor: "Bulleted list" and "Numbered list" buttons in the editing toolbar must be reversed in RTL wikis
T40548: VisualEditor: "Undo" and "Redo" buttons must be flipped for RTL environments
T40546: VisualEditor: Arrow keys move the caret in the opposite direction in RTL environment
T55542: VisualEditor: Images after template are shielded and uneditable in RTL
T55544: VisualEditor: Added templates in RTL wikis should float in appropriate direction
T55515: VisualEditor: Parameters in RTL can be duplicated in the transclusion dialog
T55503: VisualEditor: RTL entries don't receive dir="rtl" in Page settings / Languages
T35079: VisualEditor mis-positions caret in RTL text
T43009: VisualEditor: Add support for adding dir/lang attributes to paragraphs and similar elements (div, p, lists etc.)
T35175: VisualEditor: Content in an LTR wiki is displayed RTL in CE block if the interface language is RTL
Subscribers
Mooeypoo, Jdforrester-WMF, Amire80 and 6 others
Projects
Reference
bz33126
Description

Tracking bug.

Draft requirements:
https://www.mediawiki.org/wiki/Visual_editor/Bidirectional_text_requirements

Feel free to comment on them and edit them.


Version: unspecified
Severity: normal
See Also:
https://bugzilla.wikimedia.org/show_bug.cgi?id=49998
https://bugzilla.wikimedia.org/show_bug.cgi?id=49999

bzimport set Reference to bz33126.
Amire80 created this task.Via LegacyDec 14 2011, 7:28 PM
Jdforrester-WMF added a comment.Via ConduitJun 22 2012, 10:06 PM

Mass-moving items into VisualEditor product

Jdforrester-WMF added a comment.Via ConduitJun 23 2012, 1:36 AM

Mass-move out of "General" to "ContentEditable".

Amire80 added a comment.Via ConduitJul 21 2012, 11:01 AM

Adding "RTL, bidi" to the title, to make it easier to find.

Aklapper added a comment.Via ConduitApr 29 2013, 9:44 AM
  • Bug 47814 has been marked as a duplicate of this bug. ***
Qgil added a comment.Via ConduitApr 29 2013, 8:41 PM
  • Bug 47814 has been marked as a duplicate of this bug. ***
Mooeypoo added a comment.Via ConduitApr 29 2013, 9:13 PM

Submitted an application for GSoC2013 to resolve this. More information available here: http://www.mediawiki.org/wiki/User:Mooeypoo/GSOC_2013_Proposal:_RTL_Support_in_VisualEditor

(Apologies for the bug submission mixup!)

jayvdb added a comment.Via ConduitJul 22 2013, 4:37 AM

Deployment to logged in users of Hebrew Wikipedia is in two days.
https://meta.wikimedia.org/wiki/Tech/News/2013/30

Qgil added a comment.Via ConduitSep 17 2013, 4:18 PM

GSoC "soft pencils down" date was yesterday and all coding must stop on 23 September. Has this project been completed?

Amire80 added a comment.Via ConduitSep 22 2013, 3:14 AM

(In reply to comment #8)

GSoC "soft pencils down" date was yesterday and all coding must stop on 23
September. Has this project been completed?

Moriel should be writing a detailed summary now, but in short:

  • All the blocking RTL bugs, which prevented the deployment of VE in RTL language Wikipedias were resolved and the code was merged and deployed. VE is enabled in the Hebrew Wikipedia, and it's quite usable there thanks to this project.
  • RTL-compatible TemplateData editor (bug 50436) was developed as a gadget by Moriel, and it is already used in the Hebrew Wikipedia. The same code is also committed as a proper extension in https://gerrit.wikimedia.org/r/#/c/85400/ . This should be review Some Time Soon, to allow proper localization and deployment in all sites.

There will always be more RTL bugs in VisualEditor and in the rest of the Wikimedia software, so this tracker bug must not be closed. But this GSoC project definitely achieved its goal. Big, big thanks to Moriel, and to the VisualEditor team people who helped her do this - Inez, James, Roan, Krinkle, Trevor and all the rest.

Qgil added a comment.Via ConduitOct 22 2013, 7:36 PM

If you have open tasks or bugs left, one possibility is to list them at https://www.mediawiki.org/wiki/Google_Code-In and volunteer yourself as mentor.

We have heard from Google and free software projects participating in Code-in that students participating in this programs have done a great work finishing and polishing GSoC projects, many times mentores by the former GSoC student. The key is to be able to split the pending work in little tasks.

More information in the wiki page. If you have questions you can ask there or you can contact me directly.

Jdforrester-WMF moved this task to Backlog on the VisualEditor workboard.Via WebNov 27 2014, 12:57 AM

Note that almost all of the blocking tasks for this are wrongly filed; the vast majority are about the language of the user interface, not about the content. The former should be moved to VisualEditor-InterfaceLanguage; the latter to VisualEditor-ContentLanguage, and this tracking task shut down.

Amire80 added a comment.Via WebDec 3 2014, 8:30 AM

In Bugzilla it was useful to have this separate tracking bug to separate VE RTL bugs because there are a lot of them, and it's convenient to see just the non-VE RTL bugs. (There are also such trackers for Semantic MediaWiki and for the apps.)

I'd rather not shut it down entirely, but remove the word "content" from the title. Also, it doesn't have to be a tracking task, but an RTL tag, which would also replace T2745, and then we won't need a special tag or task for the combination of VE and RTL.

Jdforrester-WMF added a comment.Via WebDec 3 2014, 5:19 PM

In Bugzilla it was useful to have this separate tracking bug to separate VE RTL bugs because there are a lot of them, and it's convenient to see just the non-VE RTL bugs. (There are also such trackers for Semantic MediaWiki and for the apps.)

I'd rather not shut it down entirely, but remove the word "content" from the title. Also, it doesn't have to be a tracking task, but an RTL tag, which would also replace T2745, and then we won't need a special tag or task for the combination of VE and RTL.

Why not have a tag called "RTL issues" then? This can be applied to tasks in all projects, rather than have this disaster of complication.

RTL content issues are often very hard to fix; RTL interface issues, however, are generally easy oversights in our usual work. Jumbling them together makes the hard tasks get less attention and priority.

Amire80 added a comment.Via WebDec 3 2014, 7:21 PM

Yes, I support it. I'll probably ask the Phab gurus for advice with this soon. (Not the most important thing on my plate at the moment.)

Qgil removed a subscriber: Qgil.Via WebDec 3 2014, 7:26 PM
Krinkle removed a subscriber: Krinkle.Via WebDec 8 2014, 2:25 AM
Jdforrester-WMF closed this task as "Resolved".Via WebJan 28 2015, 6:03 AM
Jdforrester-WMF claimed this task.

Replaced with projects.

Add Comment

Column Prototype
This is a very early prototype of a persistent column. It is not expected to work yet, and leaving it open will activate other new features which will break things. Press "\" (backslash) on your keyboard to close it now.